#include <stdio.h>
#include "defs.h"

har   *progname;
har   *filename;
ixrect *pr;

#ifdef STANDALONE
ain(argc, argv, envp)
#else
ox_main(argc, argv, envp)
#endif
	int     argc;
	char  **argv;
	char  **envp;
{
	register int i, j;
	int     levels;
	colormap_t colormap;

	progname = strsave(argv[0]);
	parse_profile(&argc, argv, envp);

	while ((gc = getopt(argc, argv, " ")) != EOF)
		switch (gc) {
		case '?':
			errflag++;
			break;
		}

	if (errflag)
		error((char *) 0, "Usage: %s: [infile] [outfile]\n", progname);

	for (stream = 0; optind < argc; stream++, optind++)
		if (stream < 2 && strcmp(argv[optind], "-") != 0)
			if (freopen(argv[optind], mode[stream], f[stream]) == NULL)
				error("%s %s", PR_IO_ERR_INFILE, argv[optind]);

	if ((pr = pr_load(stdin, &colormap)) == NULL)
		error(PR_IO_ERR_RASREAD);

	if (bitrestrict)
		levels = calc_max(pr)+1;
	else
		levels = MAXLEVEL(pr->pr_depth);

	pr_vector(pr, 0, 0, pr->pr_size.x - 1, 0, PIX_SRC, levels);
	pr_vector(pr, pr->pr_size.x - 1, 0, pr->pr_size.x - 1, pr->pr_size.y - 1, PIX_SRC, levels);
	pr_vector(pr, pr->pr_size.x - 1, pr->pr_size.y - 1, 0, pr->pr_size.y - 1, PIX_SRC, levels);
	pr_vector(pr, 0, pr->pr_size.y - 1, 0, 0, PIX_SRC, levels);

	pr_dump(pr, stdout, &colormap, RT_STANDARD, 0);
}
