#include <stdio.h>
#include "defs.h"

har           *progname;
har           *filename;
ixrect        *pr;

#ifdef STANDALONE
ain(argc, argv, envp)
#else
asrange_main(argc, argv, envp)
#endif
	int             argc;
	char          **argv;
	char          **envp;
{
	register int    i, j;
	int             pix, bottom, top;
	int             levels;
	colormap_t		colormap;

	bottom = top = 0;
	progname = strsave(argv[0]);
	parse_profile(&argc, argv, envp);

	while ((gc = getopt(argc, argv, "l:h:")) != EOF)
		switch (gc) {
		case 'l':
			bottom = atoi(optarg);
			break;
		case 'h':
			top = atoi(optarg);
			break;
		case '?':
			errflag++;
			break;
		}

	if (errflag)
		error((char *) 0, "Usage: %s: [-l low-val] [-h high-val] [infile] [outfile]\n", progname);

	for (stream = 0; optind < argc; stream++, optind++)
		if (stream < 2 && strcmp(argv[optind], "-") != 0)
			if (freopen(argv[optind], mode[stream], f[stream]) == NULL)
				error("%s %s", PR_IO_ERR_INFILE, argv[optind]);

	if ((pr = pr_load(stdin, &colormap)) == NULL)
		error(PR_IO_ERR_RASREAD);

	if (bitrestrict)
		levels = calc_max(pr)+1;
	else
		levels = MAXLEVEL(pr->pr_depth);

	if (top == 0)
		top = levels;

	for (j = 0; j < pr->pr_size.y; j++)
		for (i = 0; i < pr->pr_size.x; i++) {
			pix = (pr_get(pr, i, j) - bottom) * levels / (top - bottom);
			pix = MAX(pix, 0);
			pr_put(pr, i, j, MIN(pix, levels));
		}

	pr_dump(pr, stdout, &colormap, RT_STANDARD, 0);
}
